/* $Id $
	------------------------------------------------------------------
	Copyright (C) 2012 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
*/

var Popup = function()
{
	
	var popup = {};

	popup.initPage = function()
	{
		Events.addEventHandler(document.body, 'click', popup.closeIt);
		var wait = Data.int('page-data', 'wait');
		if (wait > 0)
		{
			setTimeout(popup.closeIt, wait);
		}
		else
		{
			popup.closeIt();
		}
	}
	
	
	popup.closeIt = function()
	{
		var myOpener = window.top.opener;
		var redirectOpener = Data.get('page-data', 'redirect-opener');
		var refreshOpener = Data.int('page-data', 'refresh-opener');
		var notifyOpener = Data.get('page-data', 'notify-opener');
		if (notifyOpener)
		{
			var notifyTarget = myOpener.document.getElementById(notifyOpener);
			if (notifyTarget)
			{
				var evt = myOpener.document.createEvent('CustomEvent');
				evt.initEvent('base-notify', false, true);
				notifyTarget.dispatchEvent(evt);
			}
		}
		else if (redirectOpener)
		{
			myOpener.location.href = redirectOpener;
		}
		else if (refreshOpener)
		{
			myOpener.location.reload();
		}
		App.closeWindow();
	}
	
	return popup;
}();

Doc.onLoad(Popup.initPage);


