<%-- $Id $
	------------------------------------------------------------------
	Copyright (C) 2010 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.FileServer"
	import="net.sf.basedb.core.MultiPermissions"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.MD5"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.util.uri.ConnectionManagerFactory"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="net.sf.basedb.util.extensions.ExtensionsUtil"
	import="net.sf.basedb.util.uri.ConnectionManagerUtil"
	import="java.util.Date"
	import="java.util.Collections"
	import="java.util.Map"
	import="java.util.Set"
	import="java.security.cert.X509Certificate"
	import="java.security.cert.CertificateExpiredException"
	import="java.security.MessageDigest"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.FILESERVER;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
	
	String getMd5FingerPrint(X509Certificate cert)
		throws Exception
	{
		MessageDigest md5 = MD5.newInstance();
		md5.update(cert.getEncoded());
		return formatFingerPrint(MD5.getHashString(md5));
	}
	
	String getSha1FingerPrint(X509Certificate cert)
		throws Exception
	{
		MessageDigest sha1 = MessageDigest.getInstance("SHA1");
		sha1.update(cert.getEncoded());
		return formatFingerPrint(MD5.getHashString(sha1));
	}
	
	/**
		Puts a : between every two characters and convert to uppercase
	*/
	String formatFingerPrint(String fingerPrint)
	{
		return fingerPrint.replaceAll("(..)(?=.)", "$1:").toUpperCase();
	}
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);

	FileServer server = FileServer.getById(dc, itemId);
	String title = "File server -- " + HTML.encodeTags(server.getName());
	
	final boolean writePermission = server.hasPermission(Permission.WRITE);
	final boolean deletePermission = server.hasPermission(Permission.DELETE);
	final boolean sharePermission = server.hasPermission(Permission.SET_PERMISSION);
	final boolean usePermission = server.hasPermission(Permission.USE);
	final boolean setOwnerPermission = server.hasPermission(Permission.SET_OWNER);
	final boolean isRemoved = server.isRemoved();
	final boolean isUsed = isRemoved && server.isUsed();
	final boolean deletePermanentlyPermission = deletePermission && !isUsed;
	final boolean isOwner = server.isOwner();
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, server);
	ExtensionsInvoker invoker = ToolbarUtil.useExtensions(jspContext);
	ConnectionManagerFactory cmf = ConnectionManagerUtil.getFactory(server.getConnectionManagerFactoryId());
	%>
	<base:page title="<%=title%>" id="view-page">
	<base:head scripts="table.js,tabcontrol-2.js,~fileservers.js" styles="table.css,toolbar.css,headertabcontrol.css,path.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	<base:body>
		<p:path><p:pathelement 
			title="File servers" href="<%="index.jsp?ID="+ID%>" 
			/><p:pathelement title="<%=HTML.encodeTags(server.getName())%>" 
			/></p:path>
		<div id="page-data" data-item-id="<%=itemId%>"></div>
		
		<t:tabcontrol 
			id="main" 
			subclass="content mastertabcontrol"
			active="properties">
		<t:tab id="properties" title="Properties">
			<div>
			<table class="fullform bottomborder">
			<tr>
				<th class="itemstatus">
					<base:icon 
						image="shared.png" 
						visible="<%=server.isShared()%>"
						tooltip="This item is shared to other users, groups and/or projects"
					/>
					<base:icon 
						id="btnDeletePermanently"
						image="deleted.png"
						tooltip="This item has been flagged for deletion. Click to delete it now."
						enabled="<%=deletePermanentlyPermission %>"
						visible="<%=isRemoved%>" 
					/>
					<base:icon 
						id="btnUsingItems"
						image="used.png" 
						tooltip="This item is used by other items and can't be permanently deleted. Show the items that are using this one"
						visible="<%=isRemoved && isUsed%>" />
				</th>
				<td style="padding: 0px;">
					<tbl:toolbar subclass="bottomborder bg-filled-50">
						<tbl:button 
							id="btnEdit"
							disabled="<%=!writePermission%>" 
							image="edit.png" 
							title="Edit&hellip;" 
							tooltip="<%=writePermission ? "Edit this file server" : "You do not have permission to edit this file server"%>" 
						/>
						<tbl:button 
							id="btnDelete"
							disabled="<%=!deletePermission%>" 
							image="delete.png" 
							title="Delete"
							visible="<%=!server.isRemoved()%>"
							tooltip="<%=deletePermission ? "Delete this file server" : "You do not have permission to delete this file server"%>" 
						/>
						<tbl:button 
							id="btnRestore"
							disabled="<%=!writePermission%>" 
							image="restore.png" 
							title="Restore"
							visible="<%=server.isRemoved()%>"
							tooltip="<%=writePermission ? "Restore this file server" : "You do not have permission to restore this file server"%>" 
						/>
						<tbl:button 
							id="btnShare"
							disabled="<%=!sharePermission%>"
							image="share.png"
							title="Share&hellip;" 
							tooltip="<%=sharePermission ? "Share this file server to other user, groups and projects" : "You do not have permission to share this file server"%>"
						/>
						<tbl:button 
							id="btnSetOwner"
							disabled="<%=!setOwnerPermission%>"
							image="take_ownership.png"
							title="Set owner&hellip;"
							tooltip="<%=setOwnerPermission ? "Change owner of this item" : "You do not have permission to change ownership of this item"%>"
						/>
						<tbl:button 
							id="btnImport"
							image="import.png" 
							data-plugin-type="IMPORT"  
							title="Import&hellip;" 
							tooltip="Import data" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
						/>
						<tbl:button 
							id="btnExport"
							image="export.png"
							data-plugin-type="EXPORT" 
							title="Export&hellip;" 
							tooltip="Export data" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
						/>
						<tbl:button 
							id="btnRunPlugin"
							image="runplugin.png"  
							data-plugin-type="OTHER" 
							title="Run plugin&hellip;" 
							tooltip="Run a plugin" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
						/>
						<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
							wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
						<tbl:button
							image="help.png"
							subclass="auto-init"
							data-auto-init="help"
							data-help-id="fileserver.view.properties"
							title="Help&hellip;"
							tooltip="Get help about this page"
						/>	
					</tbl:toolbar>
				</td>
			</tr>
			<tr>
				<th>Name</th>
				<td><%=HTML.encodeTags(server.getName())%></td>
			</tr>
			<tr>
				<th>ConnectionManager</th>
				<td><%=cmf == null ? "<i>- auto -</i>" : HTML.encodeTags(cmf.getDisplayName())%></td>
			</tr>
			<tr>
				<th>Host</th>
				<td><%=HTML.encodeTags(server.getHost())%></td>
			</tr>
			<tr>
				<th>Username</th>
				<td><%=HTML.encodeTags(server.getUsername())%></td>
			</tr>
			<tr>
				<th>Has password</th>
				<td><%=server.hasPassword() ? "yes" : "no"%></td>
			</tr>
			<tr>
				<th>Root path</th>
				<td><%=HTML.encodeTags(server.getRootPath()) %></td>
			</tr>
			<tr>
				<th>SSH fingerprint</th>
				<td><%=HTML.encodeTags(server.getFingerprintType()) + ": " + HTML.encodeTags(server.getSshFingerprint()) %></td>
			</tr>
			<tr>
				<th>Owner</th>
				<td><base:propertyvalue item="<%=server%>" property="owner"/></td>
			</tr>
			<tr>
				<th>Permissions</th>
				<td><%=PermissionUtil.getFullPermissionNames(server)%></td>
			</tr>
			<tr>
				<th>Description</th>
				<td><%=HTML.niceFormat(server.getDescription())%></td>
			</tr>
			
			<%
			String error = null;
			X509Certificate cert = null;
			try
			{
				cert = server.getServerX509Certificate();
				if (cert != null) cert.checkValidity();
			}
			catch (CertificateExpiredException ex)
			{
				error = "This certificate has expired";
			}
			catch (Exception ex)
			{
				error = ex.getMessage();
			}
			%>
			<tr>
				<th>Server certificate</th>
				<%
				if (error != null)
				{
					%>
					<td><div class="messagecontainer error"><%=HTML.encodeTags(error)%></div></td>
					<%
				}
				else if (cert == null)
				{
					%>
					<td>no</td>
					<%
				}
			%>
			</tr>
			<%
			if (cert != null)
			{
				%>
				<tr>
					<th class="subprompt">- issued to</th>
					<td><%=cert.getSubjectX500Principal().getName() %></td>
				</tr>
				<tr>
					<th class="subprompt">- issued by</th>
					<td><%=cert.getIssuerX500Principal().getName() %></td>
				</tr>
				<tr>
					<th class="subprompt">- valid between</th>
					<td><%=dateFormatter.format(cert.getNotBefore()) %> —
						<%=dateFormatter.format(cert.getNotAfter()) %></td>
				</tr>
				<tr>
					<th class="subprompt">- serial number</th>
					<td><%=cert.getSerialNumber() %></td>
				</tr>
				<tr>
					<th class="subprompt">- MD5 fingerprint</th>
					<td><%=getMd5FingerPrint(cert)%></td>
				</tr>
				<tr>
					<th class="subprompt">- SHA1 fingerprint</th>
					<td><%=getSha1FingerPrint(cert)%></td>
				</tr>
				<%
			}
			%>
			<%
			error = null;
			cert = null;
			try
			{
				cert = server.getClientX509Certificate();
				if (cert != null) cert.checkValidity();
			}
			catch (CertificateExpiredException ex)
			{
				error = "This certificate has expired";
			}
			catch (Exception ex)
			{
				error = ex.getMessage();
			}
			%>
			<tr>
				<th>Client certificate</th>
				<%
				if (error != null)
				{
					%>
					<td><div class="messagecontainer error"><%=HTML.encodeTags(error)%></div></td>
					<%
				}
				else if (cert == null)
				{
					%>
					<td>no</td>
					<%
				}
				%>
			</tr>
			<%
			if (cert != null)
			{
				%>
				<tr>
					<th class="subprompt">- issued to</th>
					<td><%=cert.getSubjectX500Principal().getName() %></td>
				</tr>
				<tr>
					<th class="subprompt">- issued by</th>
					<td><%=cert.getIssuerX500Principal().getName() %></td>
				</tr>
				<tr>
					<th class="subprompt">- valid between</th>
					<td><%=dateFormatter.format(cert.getNotBefore()) %> —
						<%=dateFormatter.format(cert.getNotAfter()) %></td>
				</tr>
				<tr>
					<th class="subprompt">- serial number</th>
					<td><%=cert.getSerialNumber() %></td>
				</tr>
				<tr>
					<th class="subprompt">- MD5 fingerprint</th>
					<td><%=getMd5FingerPrint(cert)%></td>
				</tr>
				<tr>
					<th class="subprompt">- SHA1 fingerprint</th>
					<td><%=getSha1FingerPrint(cert)%></td>
				</tr>
				<%
			}
			%>
			</table>
			</div>
			<jsp:include page="../../common/anytoany/list_anytoany.jsp">
				<jsp:param name="ID" value="<%=ID%>" />
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="title" value="Other items related to this file server" />
			</jsp:include>
			<jsp:include page="../../common/share/list_share.jsp">
				<jsp:param name="ID" value="<%=ID%>" />
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="title" value="Shared to" />
			</jsp:include>
		</t:tab>
		</t:tabcontrol>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
